package QBank::DataBase;

use DBI;
use QBank::BankUtils;
use Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(&db $dbh); # dbh exported so qbankd can set it externally

###############################################################
# db($statement)
# This uses perl DBI module (database interface)
# to interface to a database command
# QBank disables autocommit so must explicitly commit all transactions
# except for those within WORK blocks (in which WORK is set)
# Returns ($error,@result) where error is null if command is successful
###############################################################
sub db {
local($statement)=@_;
local($rc);

$error="";
@result=();

&bank_log(0,$statement);
$sth = $dbh->prepare($statement);
if ($DBI::err) { $error="DBI Prepare: $DBI::err: $DBI::errstr"; return 0}
$rc = $sth->execute();
if ($DBI::err) { $error="DBI Execute: $DBI::err: $DBI::errstr"; return 0}

# Fetch all rows if a select statement
if ($statement =~ /^select/) {
	while ( @row=$sth->fetchrow()) { push(@result,join('|',@row)); }
	$qr=join("\n",@result);
	&bank_log(0,"QBank::DataBase::result=$qr");
	}
$rows=$DBI::rows;
$dbh->commit unless $WORK;

return 1;
}

1;

