package QBank::Result;

##############################################################
#
# Result class data members
#
# $status  Contains true or false (0|1)
# $msg     Contains error or success contextual message
#
##############################################################

require "qbank.ph";
use Exporter;
use QBank::BankUtils;
@ISA = qw(Exporter);
@EXPORT = qw(%ARGS success array failure usage);

###############################################################
# success($rv,[$msg])
###############################################################
sub success {
($rv,$msg)=@_;
$ARGS{STATUS}=1;
#$status=1;		# Set status to true
$ARGS{MESSAGE}=$msg;
return $rv;		# Return return value
}

###############################################################
# array(@GET)
###############################################################
sub array {
#$status=1;		# Set status to true
$ARGS{STATUS}=1;
#$msg="";		# Set msg to NULL
$ARGS{MESSAGE}="";
return @_;		# Return Array
}

###############################################################
# failure($error)
###############################################################
sub failure {
#$status=0;		# Set status to false
$ARGS{STATUS}=0;
#$msg=shift;		# Set passed error msg
$ARGS{MESSAGE}=shift;

# Perform rollback if failure occurred within a transaction
if ($WORK) { $::dbh->rollback; undef $WORK; }

&bank_log(1,"Message=$ARGS{MESSAGE}");	# Log error
return "";		# Return NULL string
}

###############################################################
# usage($syntax)
###############################################################
sub usage {
$syntax=shift;
#$status=0;		# Set status to false
$ARGS{STATUS}=0;
#$msg="Usage: $syntax";	# Set Usage in msg
$ARGS{MESSAGE}="Usage: $syntax"; # Set Usage in msg

&bank_log(0,$ARGS{MESSAGE}); 	# Print only to DEBUGLOG
return "";		# Return NULL string
}

1;

